package ucl.salinization.displays;

import java.awt.Color;

import repast.simphony.visualization.gis3D.GIS3DShapeFactory;
import repast.simphony.visualization.gis3D.Material;
import repast.simphony.visualization.gis3D.MaterialFactory;
import repast.simphony.visualization.gis3D.RenderableShape;
import repast.simphony.visualization.gis3D.style.StyleGIS3D;

/**
 * The city display style for visualization.
 * @author 
 *
 */
public class CityStyle implements StyleGIS3D<City>{

	/**
	 * Return the city's shape.
	 * @param city the city object to return its shape
	 */
	public RenderableShape getShape(City city) {

		//get the 3D shape
		RenderableShape shape = GIS3DShapeFactory.createSphere(6); 

		return shape;		
		
//		return new CircleShape();
	}

	/**
	 * Set the material and color for the city's visual display.
	 * @param city the city 
	 * @param material the material for the city
	 */
	public Material getMaterial(City city, Material material) {
		//the Material object used for 3D display
		if (material == null) 
			material = new Material();

		Color color = null;

		//transparency of the city visual object is set
		float transparency = 0.75f;
		
		if (city.isCapital())
			color = new Color(1,1,0,transparency);
		else
			color = new Color(0,0,1,transparency);

		return MaterialFactory.setMaterialAppearance(material, color);

	}

	public float[] getScale(City city) {
		return null;
	}

	public boolean isScaled(City city) {
		return false;
	}
}