package ucl.salinization.displays;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Font;
import java.awt.Paint;
import java.awt.Stroke;

import repast.simphony.visualization.gisnew.GeoShape;
import repast.simphony.visualization.gisnew.GeoShapeFactory;
import repast.simphony.visualization.gisnew.GeoShape.FeatureType;
import repast.simphony.visualization.gisnew.StyleGIS;
import ucl.salinization.model.physical.Field;
import ucl.salinization.model.physical.HydrologicalUnit;
import ucl.salinization.social.Person;

/**
 * 
 * @author
 *
 * @param <T>
 */
public class DefaultStyleGIS<T> implements StyleGIS<T> {

	
	public FeatureType getFeatureType(T obj) {
		if(obj instanceof Field){
			return FeatureType.POLYGON;
		}
		else if(obj instanceof HydrologicalUnit){
			return FeatureType.LINE;
		}
		else
			return FeatureType.POINT;
	}
	public GeoShape getShape(T obj) {		
		GShape gshape= new GShape();
		gshape.setGeometry(obj);
		
		return gshape;
		
	}
	public Stroke getBorder(T obj) {
		if(obj instanceof Field){
			Field f=(Field)obj;
			if(f.getFieldType()==0)
				return new BasicStroke(1.0f);
		}
		return new BasicStroke(1.0f);
	}
	public Color getBorderColor(T obj) {
		if(obj instanceof HydrologicalUnit)
			return Color.BLUE;
		else if(obj instanceof Field){
			Field f = (Field) obj;
			if(f.getFieldType()==-1 && f.getId()!=237 && f.getId()!=239)
				return new Color(255,255,255);
			if(f.getFieldType()==0)
				return new Color(0,255,0);
			else
				return new Color(0,0,0);
		}
		else 
			return Color.RED;
	}
	public double getBorderOpacity(T obj) {
		return 1.0;
	}
	
	
	public Color getFillColor(T obj) {
		Color c =null;
		if(obj instanceof HydrologicalUnit)
			c= Color.BLUE;
		else if(obj instanceof Field){
			Field f = (Field) obj;
			c=new Color(245,222,179);
			if(f.getFallowYears()>2)
				 c=new Color(255,160,122);
			if(f.getFallowYears()>5)
				c=new Color(255,165,0);
			if(f.getFallowYears()>10)
				c=new Color(224,140,0);
			if(f.getFallowYears()>15)
				c=new Color(255,99,71);
			if(f.getFallowYears()>20)
				c=new Color(255,69,0);
			if(f.getFallowYears()>25)
				c=new Color(255,0,0);
		}
		else 
			c=Color.GREEN;
		return c;
	}
	public double getFillOpacity(T obj) {
		return 0.0;
	}
	public String getLabel(T obj) {
		if(obj instanceof Field){
			Field f = (Field)obj;
		}
		return null;
	}
	public Color getLabelColor(T obj) {
		return null;
	}
	public Font getLabelFont(T obj) {
		return null;
	}
	public float getRotation(T obj) {
		return 0;
	}
	public float getScale(T obj) {
		return 0;
	}
	public boolean isScaled(T object) {
		return false;
	}
	
}