package ucl.salinization.displays;

import gov.nasa.worldwind.layers.RenderableLayer;
import gov.nasa.worldwind.render.Material;
import gov.nasa.worldwind.render.Renderable;
import gov.nasa.worldwind.render.ShapeAttributes;
import gov.nasa.worldwind.render.SurfacePolygon;
import gov.nasa.worldwind.layers.Layer;

import java.awt.Color;
import java.awt.Paint;
import java.util.Iterator;

import com.vividsolutions.jts.geom.Geometry;

import repast.simphony.engine.environment.RunState;
import repast.simphony.visualization.gisnew.GeoShape;
import repast.simphony.visualization.gisnew.NewDisplayGIS;
import repast.simphony.visualization.gisnew.StyleGIS;
import repast.simphony.visualization.gisnew.StyledSurfaceShapeLayer;
import repast.simphony.visualization.gisnew.SurfaceCircleShape;
import ucl.salinization.model.physical.Field;
import ucl.salinization.model.physical.HydrologicalUnit;
import ucl.salinization.social.Community;
import ucl.salinization.social.Person;

public class GShape extends GeoShape{

	public enum FeatureType {MultiPolygon,POINT, LINE, POLYGON, Polygon}
	
	private Renderable renderable;
//	private FeatureType type;

	public Renderable getRenderable() {
		return renderable;
	}
	public void setRenderable(Renderable renderable) {
		this.renderable = renderable;
	}
	
	public void setGeometry(Object object){
		if(object instanceof Field){
			this.renderable=((Field)object).getSurfacePolygon();
		}
		else if(object instanceof HydrologicalUnit){
			this.renderable=((HydrologicalUnit)object).getRenderable();
		}
		else if(object instanceof Person){
			this.renderable=new SurfaceCircleShape(0);
		}
		else if(object instanceof Community){
			SurfaceCircleShape scs=new SurfaceCircleShape(0);
			this.renderable=new SurfaceCircleShape(0);
		}
	}
	
	public boolean updateRederable(NewDisplayGIS gis,Field field){
		boolean found=false;
		if(this.renderable instanceof SurfacePolygon){
			SurfacePolygon sp = (SurfacePolygon)this.renderable;
			Iterator<Layer> li=
				gis.getWwglCanvas().getModel().getLayers().iterator();
			while(li.hasNext()){
				Layer l = li.next();
				
				if(l.getName().equals("Field")){
					if(l instanceof StyledSurfaceShapeLayer){
						if(((StyledSurfaceShapeLayer)l).getVisualItem(field).equals(this)){
							gis.getWwglCanvas().getModel().getLayers().remove(l);
							found=true;
				//	    gis.getWwglCanvas().getModel().getLayers().add(l);
				//		RenderableLayer rl = new RenderableLayer();
				//		rl.addRenderable(sp);
				//		gis.getWwglCanvas().getModel().getLayers().add(l);
						}
					}
				}
			}
	//		RenderableLayer rl = new RenderableLayer();
	//		rl.addRenderable(sp);
	//		gis.getWwglCanvas().getModel().getLayers()
	//		gis.render();
		}
		return found;
	}

//	public FeatureType getType() {
//		return type;
//	}
//	public void setType(FeatureType type) {
//		this.type = type;
//	}
}