/**
 * 
 */
package ucl.salinization.output;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import org.geotools.data.DataUtilities;
import org.geotools.feature.Feature;
import org.geotools.feature.FeatureCollection;
import org.geotools.feature.FeatureCollections;
import org.geotools.feature.FeatureType;

import repast.simphony.engine.environment.RunEnvironment;
import repast.simphony.engine.environment.RunState;

import ucl.salinization.model.physical.Field;


import com.vividsolutions.jts.geom.Geometry;


/**
 * Output class for data related to the structure
 * @author 
 *
 */
public class FieldOutput implements GISOutput{
	
	private double volume;
	private static int maxVolume;
	
	/**
	 * Comperator for traffic volume passed by structures
	 * @author Mark Altaweel
	 *
	 */
	class passByComparator implements Comparator{
		public int compare(Object o1, Object o2){
/*			Structure e1 = (Structure) o1;
			Structure e2 = (Structure) o2;
			int passByComp = (e1.getPassedBy()< e2.getPassedBy() ? -1
			         : (e1.getPassedBy() == e2.getPassedBy() ? 0 : 1));*/
			   
			return 1;
			 
		}
	}
	public void calcMaxTraffic(){
	/*	Object[] structures = ApplicationData.SimulationData.getStructures().toArray();
		for(int i=0; i<structures.length; i++){
			Structure s = (Structure)structures[i];
			s.determineNumberPassed();;
		}
		Arrays.sort(structures, new passByComparator());
		this.maxVolume = ((Structure)structures[structures.length -1]).getPassedBy();
		System.out.println("Structure Id = " +
				((Structure)structures[structures.length -1]).getFeatureID() +
				"max passBy = " + maxVolume); */
	
	}
	/**
	
	/**
	 * Determine how often the structure was passed by relative to other structures
	 */
	public  void initiateCalculation(Object e){
		
//		if(this.maxVolume!=0)
//			volume= (double)(((Structure)e).getPassedBy() / (double)maxVolume);
//		else
//			volume=0;
	}
	
	  public static void writeShapefile(List<Field> poly,String category) throws Exception {
		   
		    File shpFile = new File("../Salinization/output/","fieldOutput"+category+".shp");	
		  
			ShapefileWriter writer = new ShapefileWriter();
			FeatureType featureType=DataUtilities.createType("fieldOutput", 
					"geom:MultiPolygon,Tick:java.lang.Double,FNumber:java.lang.Integer,FType:java.lang.Integer,FSalt:java.lang.Double,FYield:java.lang.Double,FName:java.lang.String");
			FeatureCollection collection = createCollection(poly,featureType);
			writer.write(shpFile,collection,featureType);
		   
		 }

	  /**
	   * Method to create a feature collection of structure objects in shulgi
	   * @param fields the structures
	   * @param featureType the feature type containing the attributes for a shapefile
	   * @return a feature collection
	   * @throws Exception an exception with the data
	   */
	public static FeatureCollection createCollection(List<Field> fields, FeatureType
			featureType) throws Exception{
		 FeatureCollection collection = FeatureCollections.newCollection();
		 double tick = RunEnvironment.getInstance().getCurrentSchedule().getTickCount();
		Iterator<Field> ic = fields.iterator();
		while(ic.hasNext()){
			  Field f = ic.next();
			  int number=f.getId();
			  int type=f.getFieldType();
			  double salinization=f.getSaltCompounds();
			  double yield=f.getFallowYears();
			  String name=f.getName();
			  Geometry g =f.getPoly();
			  
			  Feature feature = featureType.create(new Object[] {g,tick,number,type,
					  salinization,yield,name});
			  collection.add( feature );
		  }
		 return collection;
	}

	public void writeOutput(String timeStamp){
		{
			FileWriter fw= null;
			PrintWriter pw= null;

			// Open a file for output
		    System.out.println("writing output");
			String fileName= "CompoundOutput"+timeStamp;
			String outputDirectory= "../Shulgi/Shulgi_Data/Output/";
				
			String filename= outputDirectory+fileName+ ".txt";
		
			try
			{
				fw= new FileWriter( new File(filename) );
				pw=  new PrintWriter( fw );
					
				Iterator<Field> ic=
		    		  RunState.getInstance().getMasterContext().getAgentLayer(Field.class).iterator();
				
				pw.println("Feature Id" + "\t" +"Category" +"\t"+"Traversed");
				
				while( ic.hasNext()){
					Field f = ic.next();
					
							
				} 

				pw.close();
			} 
			catch( IOException e )
			{
				e.printStackTrace();
			}
		}	
	}
	public double getVolume() {
		return volume;
	}
	
	@Override
	public void writeShapefile(String category) throws Exception {
		// TODO Auto-generated method stub
		
	}
	
}
