package ucl.salinization.output;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.io.FileUtils;

import repast.simphony.engine.environment.RunEnvironment;
import repast.simphony.engine.environment.RunState;
import ucl.salinization.model.physical.Field;

public class Outputter {

	static int runNumber=0;
	static String seperator=",";
	static String fileName=".."+File.separator+"Salinization"+File.separator+"output"+File.separator+"ModelOutput";
	static String fieldName=".."+File.separator+"Salinization"+File.separator+"output"+File.separator+"FieldOutput";
	static String titleLine="Tick,Field Number,Field Type,Salinization,Yield,Fallow Year,Fallow Fields,Field Name";
	static String fieldLine="Tick,Field Number,Field Type,Salinization,Yield,Fallow Year,Fallow Fields,Field Name";
	
	static Map<Field,Double>flds=new HashMap<Field,Double>();
	public void writeData(List<String> lines){
		List<String> oldLines=null;
		double tick=RunEnvironment.getInstance().getCurrentSchedule().getTickCount();
		
		if(new File(fileName+runNumber+".csv").exists() && tick>1){
			try {
				oldLines=FileUtils.readLines(new File(fileName+runNumber+".csv"));
				oldLines.remove(0);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		if(oldLines!=null){
			oldLines.addAll(lines);
			lines=oldLines;
		}
		String fName=fileName+runNumber;
		try {
			lines.add(0, titleLine);
			FileUtils.writeLines(new File(fName+".csv"), lines);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		int length=(Integer)RunEnvironment.getInstance().getParameters().getValue("simLength");
		if(tick==length){
			lines.remove(0);
		}
	}
		
	public static void clearFile(){
		runNumber=RunState.getInstance().getRunInfo().getRunNumber();
		if(new File(fieldName+runNumber+".csv").exists()){
			new File(fieldName+runNumber+".csv").delete();
		}
	}
	
	public static void writeFileData(double tick,List<Field>fields){
		runNumber=RunState.getInstance().getRunInfo().getRunNumber();
		List<String>lines = new ArrayList<String>();
		List<String> oldLines=null;
		
		if(RunEnvironment.getInstance().getCurrentSchedule().getTickCount()<8)
			flds.clear();
		
		int n=0;
		for(Field f: fields){
			n++;
			int fallowField=0;
			
			double yield=f.getYield();
			if(f.getStatus()==Field.FALLOW_FIELD ){
		//		yield=0;
				fallowField=1;
				if(flds.containsKey(f)){
					Double value=flds.get(f);
					if(value==f.getYield())
						yield=0;
				}
//				if(f.getFallowYears()>0 && f.isOnce()){
//					yield=f.getYield();
//					f.setOnce(false);
//				}
//				else
//				if(f.getFallowYears()!=0)
//					yield=0;
			}
			String line="";
			if(!(f.getYield()>=0.0) && !(f.getYield()<=1.0)){
				System.out.println("stop");
			}
				line=tick+seperator+f.getId()+seperator
				+f.getFieldType()+seperator+f.getSaltCompounds()+seperator+yield+seperator+f.getFallowYears()+seperator+fallowField+seperator+f.getName();
			
			lines.add(line);
			flds.put(f, f.getYield());
		}
		if(new File(fieldName+runNumber+".csv").exists() && tick>=0.0){
			try {
				oldLines=FileUtils.readLines(new File(fieldName+runNumber+".csv"));
				oldLines.remove(0);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		if(oldLines!=null){
			oldLines.addAll(lines);
			lines=oldLines;
		}
		try {
			lines.add(0, fieldLine);
			FileUtils.writeLines(new File(fieldName+runNumber+".csv"), lines);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
